public inbox for linux-riscv@lists.infradead.org
 help / color / mirror / Atom feed
* [PATCH v2 0/2] riscv: Dump faulting instructions in oops handler
@ 2023-01-16  7:38 Björn Töpel
  2023-01-16  7:38 ` [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats Björn Töpel
  2023-01-16  7:38 ` [PATCH v2 2/2] scripts/decodecode: Add support for RISC-V Björn Töpel
  0 siblings, 2 replies; 5+ messages in thread
From: Björn Töpel @ 2023-01-16  7:38 UTC (permalink / raw)
  To: Paul Walmsley, Palmer Dabbelt, Albert Ou, linux-riscv
  Cc: Björn Töpel, Andreas Schwab, linux-kernel

From: Björn Töpel <bjorn@rivosinc.com>

RISC-V does not dump faulting instructions in the oops handler. This
series adds "Code:" dumps to the oops output together with
scripts/decodecode support.

Thanks,
Björn

v1->v2: Dump instructions in 16b parcels (Andreas)

Björn Töpel (2):
  riscv: Add instruction dump to RISC-V splats
  scripts/decodecode: Add support for RISC-V

 arch/riscv/kernel/traps.c | 25 ++++++++++++++++++++++++-
 scripts/decodecode        | 12 +++++++++++-
 2 files changed, 35 insertions(+), 2 deletions(-)


base-commit: 5dc4c995db9eb45f6373a956eb1f69460e69e6d4
-- 
2.37.2


_______________________________________________
linux-riscv mailing list
linux-riscv@lists.infradead.org
http://lists.infradead.org/mailman/listinfo/linux-riscv

^ permalink raw reply	[flat|nested] 5+ messages in thread

* [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats
  2023-01-16  7:38 [PATCH v2 0/2] riscv: Dump faulting instructions in oops handler Björn Töpel
@ 2023-01-16  7:38 ` Björn Töpel
  2023-01-18 10:48   ` Geert Uytterhoeven
  2023-01-16  7:38 ` [PATCH v2 2/2] scripts/decodecode: Add support for RISC-V Björn Töpel
  1 sibling, 1 reply; 5+ messages in thread
From: Björn Töpel @ 2023-01-16  7:38 UTC (permalink / raw)
  To: Paul Walmsley, Palmer Dabbelt, Albert Ou, linux-riscv
  Cc: Björn Töpel, Andreas Schwab, linux-kernel

From: Björn Töpel <bjorn@rivosinc.com>

Add instruction dump (Code:) output to RISC-V splats. Dump 16b
parcels.

An example:
  Unable to handle kernel NULL pointer dereference at virtual address 0000000000000000
  Oops [#1]
  Modules linked in:
  CPU: 0 PID: 1 Comm: swapper/0 Not tainted 6.2.0-rc3-00302-g840ff44c571d-dirty #27
  Hardware name: riscv-virtio,qemu (DT)
  epc : kernel_init+0xc8/0x10e
   ra : kernel_init+0x70/0x10e
  epc : ffffffff80bd9a40 ra : ffffffff80bd99e8 sp : ff2000000060bec0
   gp : ffffffff81730b28 tp : ff6000007ff00000 t0 : 7974697275636573
   t1 : 0000000000000000 t2 : 3030303270393d6e s0 : ff2000000060bee0
   s1 : ffffffff81732028 a0 : 0000000000000000 a1 : ff60000080dd1780
   a2 : 0000000000000002 a3 : ffffffff8176a470 a4 : 0000000000000000
   a5 : 000000000000000a a6 : 0000000000000081 a7 : ff60000080dd1780
   s2 : 0000000000000000 s3 : 0000000000000000 s4 : 0000000000000000
   s5 : 0000000000000000 s6 : 0000000000000000 s7 : 0000000000000000
   s8 : 0000000000000000 s9 : 0000000000000000 s10: 0000000000000000
   s11: 0000000000000000 t3 : ffffffff81186018 t4 : 0000000000000022
   t5 : 000000000000003d t6 : 0000000000000000
  status: 0000000200000120 badaddr: 0000000000000000 cause: 000000000000000f
  [<ffffffff80003528>] ret_from_exception+0x0/0x16
  Code: 862a d179 608c a517 0069 0513 2be5 d0ef db2e 47a9 (c11c) a517
  ---[ end trace 0000000000000000 ]---
  Kernel panic - not syncing: Attempted to kill init! exitcode=0x0000000b
  SMP: stopping secondary CPUs
  ---[ end Kernel panic - not syncing: Attempted to kill init! exitcode=0x0000000b ]---

Signed-off-by: Björn Töpel <bjorn@rivosinc.com>
---
 arch/riscv/kernel/traps.c | 25 ++++++++++++++++++++++++-
 1 file changed, 24 insertions(+), 1 deletion(-)

diff --git a/arch/riscv/kernel/traps.c b/arch/riscv/kernel/traps.c
index 549bde5c970a..b8f0ea8a9568 100644
--- a/arch/riscv/kernel/traps.c
+++ b/arch/riscv/kernel/traps.c
@@ -29,6 +29,27 @@ int show_unhandled_signals = 1;
 
 static DEFINE_SPINLOCK(die_lock);
 
+static void dump_kernel_instr(const char *loglvl, struct pt_regs *regs)
+{
+	char str[sizeof("0000 ") * 12 + 2 + 1], *p = str;
+	unsigned long addr = regs->epc;
+	long bad;
+	u16 val;
+	int i;
+
+	for (i = -10; i < 2; i++) {
+		bad = get_kernel_nofault(val, &((u16 *)addr)[i]);
+		if (!bad) {
+			p += sprintf(p, i == 0 ? "(%04hx) " : "%04hx ", val);
+		} else {
+			printk("%sCode: Unable to access instruction at 0x%lx.\n",
+			       loglvl, (long)&((u16 *)addr)[i]);
+			return;
+		}
+	}
+	printk("%sCode: %s\n", loglvl, str);
+}
+
 void die(struct pt_regs *regs, const char *str)
 {
 	static int die_counter;
@@ -43,8 +64,10 @@ void die(struct pt_regs *regs, const char *str)
 
 	pr_emerg("%s [#%d]\n", str, ++die_counter);
 	print_modules();
-	if (regs)
+	if (regs) {
 		show_regs(regs);
+		dump_kernel_instr(KERN_EMERG, regs);
+	}
 
 	cause = regs ? regs->cause : -1;
 	ret = notify_die(DIE_OOPS, str, regs, 0, cause, SIGSEGV);
-- 
2.37.2


_______________________________________________
linux-riscv mailing list
linux-riscv@lists.infradead.org
http://lists.infradead.org/mailman/listinfo/linux-riscv

^ permalink raw reply related	[flat|nested] 5+ messages in thread

* [PATCH v2 2/2] scripts/decodecode: Add support for RISC-V
  2023-01-16  7:38 [PATCH v2 0/2] riscv: Dump faulting instructions in oops handler Björn Töpel
  2023-01-16  7:38 ` [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats Björn Töpel
@ 2023-01-16  7:38 ` Björn Töpel
  1 sibling, 0 replies; 5+ messages in thread
From: Björn Töpel @ 2023-01-16  7:38 UTC (permalink / raw)
  To: Paul Walmsley, Palmer Dabbelt, Albert Ou, linux-riscv
  Cc: Björn Töpel, Andreas Schwab, linux-kernel

From: Björn Töpel <bjorn@rivosinc.com>

RISC-V has some GNU disassembly quirks, e.g. it requires '-D' to
properly disassemble .2byte directives similar to Arm [1]. Further,
GNU objdump groups RISC-V instruction by 2 or 4 byte chunks, instead
doing byte-for-byte.

Add the required switches, and translate from short/word to bytes when
ARCH is "riscv".

An example how to invoke decodecode for RISC-V:
  $ echo 'Code: bf45 f793 1007 f7d9 50ef 37af d541 b7d9 7097 00c8 (80e7)
  6140' | AFLAGS="-march=rv64imac_zicbom_zihintpause"  \
  ARCH=riscv CROSS_COMPILE=riscv64-linux-gnu- ./scripts/decodecode
  Code: bf45 f793 1007 f7d9 50ef 37af d541 b7d9 7097 00c8 (80e7) 6140
  All code
  ========
     0:   bf45                    c.j     0xffffffffffffffb0
     2:   1007f793                andi    a5,a5,256
     6:   f7d9                    c.bnez  a5,0xffffffffffffff94
     8:   37af50ef                jal     ra,0xf5382
     c:   d541                    c.beqz  a0,0xffffffffffffff94
     e:   b7d9                    c.j     0xffffffffffffffd4
    10:   00c87097                auipc   ra,0xc87
    14:*  614080e7                jalr    ra,1556(ra) # 0xc87624          <-- trapping instruction

  Code starting with the faulting instruction
  ===========================================
     0:   614080e7                jalr    ra,1556(ra)

[1] https://sourceware.org/bugzilla/show_bug.cgi?id=10263

Signed-off-by: Björn Töpel <bjorn@rivosinc.com>
---
 scripts/decodecode | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

diff --git a/scripts/decodecode b/scripts/decodecode
index b28fd2686561..8fe71c292381 100755
--- a/scripts/decodecode
+++ b/scripts/decodecode
@@ -93,6 +93,11 @@ disas() {
 		${CROSS_COMPILE}strip $t.o
 	fi
 
+	if [ "$ARCH" = "riscv" ]; then
+		OBJDUMPFLAGS="-M no-aliases --section=.text -D"
+		${CROSS_COMPILE}strip $t.o
+	fi
+
 	if [ $pc_sub -ne 0 ]; then
 		if [ $PC ]; then
 			adj_vma=$(( $PC - $pc_sub ))
@@ -126,8 +131,13 @@ get_substr_opcode_bytes_num()
 	do
 		substr+="$opc"
 
+		opcode="$substr"
+		if [ "$ARCH" = "riscv" ]; then
+			opcode=$(echo $opcode | tr ' ' '\n' | tac | tr -d '\n')
+		fi
+
 		# return if opcode bytes do not match @opline anymore
-		if ! echo $opline | grep -q "$substr";
+		if ! echo $opline | grep -q "$opcode";
 		then
 			break
 		fi
-- 
2.37.2


_______________________________________________
linux-riscv mailing list
linux-riscv@lists.infradead.org
http://lists.infradead.org/mailman/listinfo/linux-riscv

^ permalink raw reply related	[flat|nested] 5+ messages in thread

* Re: [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats
  2023-01-16  7:38 ` [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats Björn Töpel
@ 2023-01-18 10:48   ` Geert Uytterhoeven
  2023-01-18 11:08     ` Björn Töpel
  0 siblings, 1 reply; 5+ messages in thread
From: Geert Uytterhoeven @ 2023-01-18 10:48 UTC (permalink / raw)
  To: Björn Töpel
  Cc: Paul Walmsley, Palmer Dabbelt, Albert Ou, linux-riscv,
	Björn Töpel, Andreas Schwab, linux-kernel

Hi Björn,

On Mon, Jan 16, 2023 at 8:41 AM Björn Töpel <bjorn@kernel.org> wrote:
> From: Björn Töpel <bjorn@rivosinc.com>
>
> Add instruction dump (Code:) output to RISC-V splats. Dump 16b
> parcels.
>
> An example:
>   Unable to handle kernel NULL pointer dereference at virtual address 0000000000000000
>   Oops [#1]
>   Modules linked in:
>   CPU: 0 PID: 1 Comm: swapper/0 Not tainted 6.2.0-rc3-00302-g840ff44c571d-dirty #27
>   Hardware name: riscv-virtio,qemu (DT)
>   epc : kernel_init+0xc8/0x10e
>    ra : kernel_init+0x70/0x10e
>   epc : ffffffff80bd9a40 ra : ffffffff80bd99e8 sp : ff2000000060bec0
>    gp : ffffffff81730b28 tp : ff6000007ff00000 t0 : 7974697275636573
>    t1 : 0000000000000000 t2 : 3030303270393d6e s0 : ff2000000060bee0
>    s1 : ffffffff81732028 a0 : 0000000000000000 a1 : ff60000080dd1780
>    a2 : 0000000000000002 a3 : ffffffff8176a470 a4 : 0000000000000000
>    a5 : 000000000000000a a6 : 0000000000000081 a7 : ff60000080dd1780
>    s2 : 0000000000000000 s3 : 0000000000000000 s4 : 0000000000000000
>    s5 : 0000000000000000 s6 : 0000000000000000 s7 : 0000000000000000
>    s8 : 0000000000000000 s9 : 0000000000000000 s10: 0000000000000000
>    s11: 0000000000000000 t3 : ffffffff81186018 t4 : 0000000000000022
>    t5 : 000000000000003d t6 : 0000000000000000
>   status: 0000000200000120 badaddr: 0000000000000000 cause: 000000000000000f
>   [<ffffffff80003528>] ret_from_exception+0x0/0x16
>   Code: 862a d179 608c a517 0069 0513 2be5 d0ef db2e 47a9 (c11c) a517
>   ---[ end trace 0000000000000000 ]---
>   Kernel panic - not syncing: Attempted to kill init! exitcode=0x0000000b
>   SMP: stopping secondary CPUs
>   ---[ end Kernel panic - not syncing: Attempted to kill init! exitcode=0x0000000b ]---
>
> Signed-off-by: Björn Töpel <bjorn@rivosinc.com>

Thanks for your patch!

> --- a/arch/riscv/kernel/traps.c
> +++ b/arch/riscv/kernel/traps.c
> @@ -29,6 +29,27 @@ int show_unhandled_signals = 1;
>
>  static DEFINE_SPINLOCK(die_lock);
>
> +static void dump_kernel_instr(const char *loglvl, struct pt_regs *regs)
> +{
> +       char str[sizeof("0000 ") * 12 + 2 + 1], *p = str;
> +       unsigned long addr = regs->epc;

Given you never use this as an unsigned long, what about

    const u16 *insns = (u16 *)instruction_pointer(regs);

so you no longer need casts below?

> +       long bad;
> +       u16 val;
> +       int i;
> +
> +       for (i = -10; i < 2; i++) {
> +               bad = get_kernel_nofault(val, &((u16 *)addr)[i]);
> +               if (!bad) {
> +                       p += sprintf(p, i == 0 ? "(%04hx) " : "%04hx ", val);
> +               } else {
> +                       printk("%sCode: Unable to access instruction at 0x%lx.\n",

%px, so you can drop the cast to long below.

> +                              loglvl, (long)&((u16 *)addr)[i]);
> +                       return;
> +               }
> +       }
> +       printk("%sCode: %s\n", loglvl, str);
> +}
> +
>  void die(struct pt_regs *regs, const char *str)
>  {
>         static int die_counter;

Gr{oetje,eeting}s,

                        Geert

--
Geert Uytterhoeven -- There's lots of Linux beyond ia32 -- geert@linux-m68k.org

In personal conversations with technical people, I call myself a hacker. But
when I'm talking to journalists I just say "programmer" or something like that.
                                -- Linus Torvalds

_______________________________________________
linux-riscv mailing list
linux-riscv@lists.infradead.org
http://lists.infradead.org/mailman/listinfo/linux-riscv

^ permalink raw reply	[flat|nested] 5+ messages in thread

* Re: [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats
  2023-01-18 10:48   ` Geert Uytterhoeven
@ 2023-01-18 11:08     ` Björn Töpel
  0 siblings, 0 replies; 5+ messages in thread
From: Björn Töpel @ 2023-01-18 11:08 UTC (permalink / raw)
  To: Geert Uytterhoeven
  Cc: Paul Walmsley, Palmer Dabbelt, Albert Ou, linux-riscv,
	Björn Töpel, Andreas Schwab, linux-kernel

Geert Uytterhoeven <geert@linux-m68k.org> writes:

>> +static void dump_kernel_instr(const char *loglvl, struct pt_regs *regs)
>> +{
>> +       char str[sizeof("0000 ") * 12 + 2 + 1], *p = str;
>> +       unsigned long addr = regs->epc;
>
> Given you never use this as an unsigned long, what about
>
>     const u16 *insns = (u16 *)instruction_pointer(regs);
>
> so you no longer need casts below?

Indeed! Good suggestion, thank you! I'll do this change in v3.

>> +       long bad;
>> +       u16 val;
>> +       int i;
>> +
>> +       for (i = -10; i < 2; i++) {
>> +               bad = get_kernel_nofault(val, &((u16 *)addr)[i]);
>> +               if (!bad) {
>> +                       p += sprintf(p, i == 0 ? "(%04hx) " : "%04hx ", val);
>> +               } else {
>> +                       printk("%sCode: Unable to access instruction at 0x%lx.\n",
>
> %px, so you can drop the cast to long below.

Much cleaner. Thanks!


Björn

_______________________________________________
linux-riscv mailing list
linux-riscv@lists.infradead.org
http://lists.infradead.org/mailman/listinfo/linux-riscv

^ permalink raw reply	[flat|nested] 5+ messages in thread

end of thread, other threads:[~2023-01-18 11:09 UTC | newest]

Thread overview: 5+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2023-01-16  7:38 [PATCH v2 0/2] riscv: Dump faulting instructions in oops handler Björn Töpel
2023-01-16  7:38 ` [PATCH v2 1/2] riscv: Add instruction dump to RISC-V splats Björn Töpel
2023-01-18 10:48   ` Geert Uytterhoeven
2023-01-18 11:08     ` Björn Töpel
2023-01-16  7:38 ` [PATCH v2 2/2] scripts/decodecode: Add support for RISC-V Björn Töpel

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox